import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface WaitingRoomSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.7.1/docs/resources/waiting_room_settings#id WaitingRoomSettings#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Whether to allow verified search engine crawlers to bypass all waiting rooms on this zone. Defaults to `false`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.7.1/docs/resources/waiting_room_settings#search_engine_crawler_bypass WaitingRoomSettings#search_engine_crawler_bypass}
    */
    readonly searchEngineCrawlerBypass?: boolean | cdktf.IResolvable;
    /**
    * The zone identifier to target for the resource. **Modifying this attribute will force creation of a new resource.**
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.7.1/docs/resources/waiting_room_settings#zone_id WaitingRoomSettings#zone_id}
    */
    readonly zoneId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.7.1/docs/resources/waiting_room_settings cloudflare_waiting_room_settings}
*/
export declare class WaitingRoomSettings extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudflare_waiting_room_settings";
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.7.1/docs/resources/waiting_room_settings cloudflare_waiting_room_settings} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options WaitingRoomSettingsConfig
    */
    constructor(scope: Construct, id: string, config: WaitingRoomSettingsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _searchEngineCrawlerBypass?;
    get searchEngineCrawlerBypass(): boolean | cdktf.IResolvable;
    set searchEngineCrawlerBypass(value: boolean | cdktf.IResolvable);
    resetSearchEngineCrawlerBypass(): void;
    get searchEngineCrawlerBypassInput(): boolean | cdktf.IResolvable | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
